/**
 * R/Reuters SFC interface
 * Based on the tsbycount Reuters SDK example
 * Rory Winston <rory@theresearchkitchen.com>
 */

#ifndef _tsbycount_h
#define _tsbycount_h

#include <iostream>

#include "rtr/tseries.h"			
#include "rtr/tsdefdb.h"            

#include <R.h>
#include <Rinternals.h>

using namespace std;


class TSClientByCount :
	public virtual RTRTimeSeriesClient, public virtual RTRTSValDefDbClient
{
public:
    // Integer #items-based constructor	
	TSClientByCount(
			RTRTimeSeriesService& service,	
			const char* item,			
			int	num,				
			RTRTimeSeriesService::Period period,
			bool debugOn
			);

	// Date-based constructor
	TSClientByCount(
			RTRTimeSeriesService& service,	
			const char* item,			
			const char* startDate,						
			const char* endDate,
			RTRTimeSeriesService::Period period,
			bool debugOn
			);

	~TSClientByCount();

	void processSeriesComplete(RTRTimeSeries&);

	void processSeriesError(RTRTimeSeries&);

	void processSeriesInfo(RTRTimeSeries&);

	void processDefDbUpdate(RTRTSValDefDb&);
    
	void processDefDbComplete(RTRTSValDefDb&);

	SEXP& getFrame();
	bool dataReturned;

protected:
	RTRTimeSeries _series; 
	int _numSamples;
	RTRDateTime* _startDate;
	RTRDateTime* _endDate;
	bool _byDate;
	SEXP frame;
	bool _debugOn;
};

#endif 
